#version 330 core

layout(location = 0) in vec4 v_position;
layout(location = 1) in vec4 v_velocity;

out vec4 position;
out vec4 velocity;

uniform float dt;

uniform mat4 view;
uniform mat4 projection;

void main() {
  velocity = v_velocity;
  position = v_position +
             vec4(normalize(v_velocity.xyz - vec3(0.5f)), 0.0f) * dt * 5.0f;

  gl_Position = projection * view * position;
}